
#include "plg.h"
#define MAXDL 200

int Keepdl = 0;
int NDL = 0;
char DLtyp[MAXDL][4];
char DLval[MAXDL][80];
double DLx1[MAXDL];
double DLy1[MAXDL];
double DLx2[MAXDL];
double DLy2[MAXDL];
double DLp1[MAXDL];
double DLp2[MAXDL];
int DLi1[MAXDL];
int DLi2[MAXDL];
int DLi3[MAXDL];
int DLi4[MAXDL];
int DLi5[MAXDL];

char Color1[40] = "yellow";  /* active buttons */
char Color2[40] = "orange";  /* button flashes this color when selected */
char Color3[40] = "gray(0.8)"; /* inactive key entry fields */
char Color4[40] = "pink";    /* active key entry fields */

char DLbigbuf[20000];
int DLbigbufsize = 0;

#define STD_TXTSIZE 12

static int textbox(), expandtext(), buttonrow(),
 button1(), centeredtext(), ltext(), frame(), redraw_all(),
 handle_input();
static int erase(), Emeasuretext(); /* scg 6/20/03 */
static char *keyrep();

/* attributes with defaults */
static int Inputsize = 14;
static int Passwordmode = 0;
static int Buttonsize = STD_TXTSIZE;
static int Buttondefault = 0;
static long Flashtime = 150000;
static char Textalign[12];
static int Reserving_colors = 0;
static int Mono_display = 0;
static char OKstring[20] = "OK";
static char Dev = 'x';

static char bigbuf[5000];

/* ================= */
/* ================= */
/* GETGUI-LIB API */
/* ================= */
/* ================= */


/* ------------------------------- */
/* GETGUI_INIT - mandatory initialization routine */
/* ------------------------------- */
getgui_init( name, width, height, x, y )
char *name;
double width, height;
int x, y;
{
Esetsize( width, height, x, y );
Esetoutlabel( "getgui" );
PLG_set_early_defaults();
Einit( Dev );
Etextsize( STD_TXTSIZE );
DLbigbufsize = 0;
strcpy( Eprogname, "getgui" );
Errfp = stderr;

/* Reserve the necessary colors.. */
Reserving_colors = 1;
Ecolor( "white" ); Ecolor( "black" ); Ecolor( "0.8" );
if( Mono_display ){
	strcpy( Color1, "white" );
	strcpy( Color2, "0.8" );
	strcpy( Color3, "0.8" );
	strcpy( Color4, "white" );
	Ebackcolor( "white" );
	}
else 	{
	Reserving_colors = 2;
	Ecolor( Color1 ); Ecolor( Color2 ); Ecolor( Color3 ); Ecolor( Color4 );
	Ecolor( "0.7" ); Ecolor( "0.9" ); 
	}
Reserving_colors = 0;

Ebackcolor( "gray(0.8)" );
Ecolor( "black" );
return( 0 );
}
/* ------------------------------- */
/* GETGUI_SET - set misc attributes; can be used any time */
/* ------------------------------- */
/* Supported attributes include:

	textsize   = text size
	backcolor  = background color
	color1     = color of buttons
	color2     = flash color of selected button
	color3     = color of inactive key entry field
	color4     = color of active key entry field
	flashtime  = time in microseconds that button should flash when selected
	buttonsize = pt size of button label text
	inputsize  = pt size of chars typed into input field
	okstring   = button contents that will simply return the typed text on
			entry fields and edit boxes.  Default is "OK".  May be
			set to "" for none.

	// semfile    = name of a file that will be checked every few seconds.
	//	     If the file contains Edraw commands, these will be executed.
	//	     This is a way to add asynchronous status displays.

   The following are generally transient settings and should be set and 
   then unset as desired:
	textalign  = alignment for text prompt.  C = center  L = left  (C)
	passwordmode = don't display what user types in a key entry field 1=on  0=off
	buttondefault = which button 1..n should be shown as "default choice"
	
 */
getgui_set( attr, val )
char *attr;
char *val;
{
int i;
long atol();

if( strcmp( attr, "passwordmode" )==0 ) Passwordmode = atoi( val );

else if( strcmp( attr, "inputsize" )==0 ) {
	Inputsize = atoi( val );
	if( Inputsize < 5 ) Inputsize = 14; 
	}

else if( strcmp( attr, "buttonsize" )==0 ) {
	Inputsize = atoi( val );
	if( Inputsize < 5 ) Inputsize = STD_TXTSIZE;
	}

else if( strcmp( attr, "buttondefault" )==0 ) Buttondefault = atoi( val );

else if( strcmp( attr, "backcolor" )==0 ) Ebackcolor( val );

else if( strcmp( attr, "textsize" )==0 ) { 
	i = atoi( val );
	if( i >= 4 && i < 50 ) Etextsize( i );
	else Etextsize( STD_TXTSIZE );
	}
else if( strcmp( attr, "color1" )==0 ) strcpy( Color1, val );
else if( strcmp( attr, "color2" )==0 ) strcpy( Color2, val );
else if( strcmp( attr, "color3" )==0 ) strcpy( Color3, val );
else if( strcmp( attr, "color4" )==0 ) strcpy( Color4, val );
else if( strcmp( attr, "textalign" )==0 ) {
	if( strlen( val ) < 1 ) strcpy( Textalign, "C" );
	else strcpy( Textalign, val );
	}
else if( strcmp( attr, "flashtime" )==0 ) Flashtime = atol( val );
else if( strcmp( attr, "okstring" )==0 ) strcpy( OKstring, val );
/* else if( strcmp( attr, "semfile" )==0 ) Esetsemfile( val ); */
else if( strcmp( attr, "invisible" )==0 ) { Ewindisappear(); Eflush(); }
else if( strcmp( attr, "visible" )==0 ) { Ewinappear(); Eflush(); }
else fprintf( stderr, "Warning: getgui_set was passed an unrecognized attribute name (%s)\n", attr );

return( 0 );
}



/* ------------------------------- */
/* GETGUI_BUTTONS - Display textbox and buttons; get user response.
	If more buttons than can fit on one line are specified,
	buttons are displayed in two rows. */
/* ------------------------------- */
getgui_buttons( prompt, buttons, result )
char *prompt, *buttons, *result;
{
double x, y;
int e;
int stat;
int nlines, maxlen;
double textlo;
int tworows;
char btn1[200], btn2[100];
int breakpoint, i;
double extenddown;


/* be sure we're using correct text size.. */
/* if( Ecurtextsize != STD_TXTSIZE ) Etextsize( STD_TXTSIZE ); */

/* see if we need to go to a second row of buttons.. */
tworows = 0;
/* check for an implicit line break in the buttons (an embedded newline).. */
for( i = 0; i < strlen( buttons ); i++ ) {
	if( buttons[i] == '\n' ) {
		tworows = 1;
		strcpy( btn2, &buttons[i+1] );
		strcpy( btn1, buttons );
		btn1[i] = '\0';
		if( btn1[i-1] == ',' ) btn1[i-1] = '\0';
		}
	}

/* see if button list is long enough to require two rows, if so break up somewhere.. */
if( tworows == 0 ) {
	breakpoint = (int)((EWinx / Ecurtextwidth)*0.7 );
	if( strlen( buttons ) > ( breakpoint * 1.8 ) )
		fprintf( stderr, "Warning, not all buttons may be shown (%s)\n", buttons );
	if( strlen( buttons ) > breakpoint ) {
		tworows = 1;
		for( i = breakpoint; i >= 0; i-- ) if( buttons[i] == ',' ) break;
		strcpy( btn1, buttons );
		btn1[i] = '\0';
		strcpy( btn2, &buttons[i+1] );
		}
	}

/* process any embedded sh commands.. */
expandtext( prompt, bigbuf, 5000 );

/* find number of lines and length of longest line.. */
Emeasuretext( bigbuf, &nlines, &maxlen );

/* center the text box vertically in window.. */
textlo = (EWiny/2.0) - ((nlines* Ecurtextheight)/2.0);
if( tworows && textlo < 1.0 ) textlo = 1.2;
else if( textlo < 0.7 ) textlo = 0.7;

erase();
Keepdl = 1;

if( strlen( buttons ) > 0 ) extenddown = 0.4;
else extenddown = 0.15;
textbox( bigbuf, textlo, nlines, maxlen, extenddown );
if( tworows ) {
	buttonrow( btn1, (EWinx/2.0), textlo-0.2 );
	buttonrow( btn2, (EWinx/2.0), textlo-0.8 );
	}
else buttonrow( buttons, (EWinx/2.0), textlo-0.3 );
Keepdl = 0;

Esavewin(); /* scg 6/20/03 */

if( strcmp( result, ".!nowait" )==0 ) return( 0 );
else if( strlen( buttons ) < 1 ) {
	fprintf( stderr, "No buttons defined\n" );
	return( 1 );
	}

while( 1 ) {
	Egetkey( &x, &y, &e );
	stat = handle_input( x, y, e, result );
	if( stat == 1 ) break;
	}
/* clear screen immediately, and clear display list.. */
Eclr(); Eflush(); NDL = 0;
return( 0 );
}

/* ------------------------------ */
/* GETGUI_PROGRESS - Display textbox (and optionally buttons) but 
   don't wait for user response */
/* ------------------------------ */
getgui_progress( prompt, buttons )
char *prompt;
char *buttons;
{
getgui_buttons( prompt, buttons, ".!nowait" );
Eflush();
return( 0 );
}

/* ------------------------------- */
/* GETGUI_PROGRESSCLEAR - clear a preceding popmsg */
/* ------------------------------- */
getgui_progressclear()
{
erase();
Esavewin(); /* scg 6/20/03 */
return( 0 );
}


/* ------------------------------- */
/* GETGUI_KEYINPUT - Display textbox, entry area and optionally buttons; 
	get user response */
/* ------------------------------- */
getgui_keyinput( prompt, oldval, len, buttons, result )
char *prompt, *oldval;
int len;
char *buttons;
char *result;
{
int nlines, maxlen;
double textlo, textleft;
int pos, modflag;
int mode;
double x, y;
int e, stat;
int i;
int basetextsize;
char userin[120];

/* be sure we're using correct text size.. */
/* if( Ecurtextsize != STD_TXTSIZE ) Etextsize( STD_TXTSIZE ); */

expandtext( prompt, bigbuf, 5000 );/* process any embedded sh commands.. */
Emeasuretext( bigbuf, &nlines, &maxlen );/* find # of lines and length of longest line.. */

/* center the text box vertically in window.. */
textlo = (EWiny/2.0) - ((nlines* Ecurtextheight)/2.0);
textleft = (EWinx/2.0) - ((len*Ecurtextwidth)/2.0);
if( strlen( buttons ) > 0 && textlo < 1.0 ) textlo = 1.0;
else if( textlo < 0.7 ) textlo = 0.7;

/* begin rendering.. */
erase();
Keepdl = 1;
/* do the text box.. */
textbox( bigbuf, textlo, nlines, maxlen, 0.5 );

/* determine where to place the input area.. */
basetextsize = Ecurtextsize;
Etextsize( Inputsize );
textleft = (EWinx/2.0) - ((len*Ecurtextwidth)/2.0); /* recalculate.. */
textlo -= (Ecurtextheight*1.2);
strcpy( result, oldval );
pos = strlen( result ); /* set initial cursor position to end of entry */

/* render buttons, if any.. */
if( strlen( buttons ) > 0 ) {
	Etextsize( basetextsize );
	buttonrow( buttons, (EWinx/2.0), textlo-0.4 );
	Etextsize( Inputsize );
	}

/* draw a "shadow" that will be visible if an expose occurs.. */
Emov( textleft, textlo );
Etextsize( 7 );
Etext( "[click here]" );
Etextsize( Inputsize );

/* now save.. */
Esavewin();

if( Passwordmode ) mode = 'P';
else mode = 'E';
getgui_editln( mode, result, textleft, textlo, len, &pos, &modflag );
Etextsize( basetextsize );
Keepdl = 0;


/* check last event to see if it was a mouse click; if so, 
   get button press.. */
strcpy( userin, "" );
if( EEvent > 1000 ) {
	while( 1 ) {
		i = getgui_dlfind( EEventx, EEventy );
		if( i >= 0 ) {
			if( strcmp( DLtyp[i], "B" )==0 ) handle_input( EEventx, EEventy, EEvent, userin );
			break;
			}
		Egetkey( &x, &y, &e );
		}
	}

if( strcmp( userin, OKstring )==0 ) ;
else if( strlen( userin ) > 0 ) strcpy( result, userin );

/* clear screen immediately, and clear display list.. */
Eclr(); Eflush(); NDL = 0;
return( 0 );
}

/* ------------------------------- */
/* GETGUI_EDITBOX - */
/* ------------------------------- */
getgui_editbox( prompt, maxlen, newlinemode, buttons, result )
char *prompt;
int maxlen;
char *newlinemode; /* either "asis", "none", or "everyline" */
char *buttons;
char *result;
{
int basetextsize;
int pos, modflag;
int i;
int boxwidth;
char userin[120];
int promptnlines, promptmaxlen; /* dimensions of prompt */
double promptlo; /* geometry for prompt */

DLbigbufsize = 0;
basetextsize = Ecurtextsize;

/* be sure we're using correct text size.. */
if( Ecurtextsize != STD_TXTSIZE ) Etextsize( STD_TXTSIZE );


expandtext( prompt, bigbuf, 5000 );/* process any embedded sh commands.. */
Emeasuretext( bigbuf, &promptnlines, &promptmaxlen );/* find # of lines & length of longest line.. */
promptlo = EWiny - (promptnlines*Ecurtextheight) - 0.7;

/* begin rendering.. */
erase();
Keepdl = 1;

textbox( bigbuf, promptlo, promptnlines, promptmaxlen, 0.0 );

/* render buttons, if any.. */
if( strlen( buttons ) > 0 ) {
	Etextsize( basetextsize );
	buttonrow( buttons, (EWinx/2.0), 0.5 );
	}

Esavewin();

Etextsize( Inputsize );

/* find appropriate width in cols.. */
boxwidth = (int)(((EWinx-0.5) - 0.5) / Ecurtextwidth);

pos = strlen( result );
getgui_editpp( 'E', result, 0.5, promptlo, maxlen, boxwidth, &pos, &modflag, newlinemode );

Etextsize( basetextsize );
Keepdl = 0;

/* check last event to see if it was a mouse click; if so, 
   get button press.. */
strcpy( userin, "" );
if( EEvent > 1000 ) {
	i = getgui_dlfind( EEventx, EEventy );
	if( i >= 0 ) {
		if( strcmp( DLtyp[i], "B" )==0 ) handle_input( EEventx, EEventy, EEvent, userin );
		}
	}

if( strcmp( userin, OKstring )==0 ) ;
else if( strlen( userin ) > 0 ) strcpy( result, userin );

/* clear screen immediately, and clear display list.. */
Eclr(); Eflush(); NDL = 0;
return( 0 );
}




/* ------------------------------- */
/* GETGUI_POLL - check to see if any mouse buttons or keys pressed.
 *	If so, return 1 and value of button/key is in result.
 *	If not, return 0. */
/* ------------------------------- */
getgui_poll( result )
char *result;
{
double x, y;
int e;
EEvent = 0;
Easync(); /* check for events; if there is one EEvent will be set to non-zero */
if( EEvent == 0 ) { /* no mouse click or data entry has occurred */
	strcpy( result, "" );
	return( 0 );
	}
else    {
	x = EEventx;
	y = EEventy;
	e = EEvent;
	EEvent = 0; /* reset */
	return( handle_input( x, y, e, result ) );
	}
}

#ifdef SUSPEND
/* ------------------------------- */
/* GETGUI_SEMFILE - execute any commands present in semfile.
   Should be called once every few seconds from async loops, if a semfile
	is being used.
/* ------------------------------- */
getgui_semfile()
{
Esemfile();
return( 0 );
}
#endif

/* ------------------------------- */
/* GETGUI_GETKEY - wait for user to press a keyboard key or 
 * select a button with mouse.  Result is the key or selection. */
/* ------------------------------- */
getgui_key( result )
char *result;
{
double x, y;
int e, stat;
char *keyrep();
while( 1 ) {
	Egetkey( &x, &y, &e );
	if( e > 1000 ) {
		stat = handle_input( x, y, e, result );
		if( stat ) return( 0 );
		}
	else 	{
		sprintf( result, "%s", keyrep( e ) );
		return( 0 );
		}
	}
}

/* ================== */
/* ================== */
/* INTERMEDIATE ROUTINES */
/* ================== */
/* ================== */

/* ------------------------------- */
/* TEXTBOX - lines of centered text in a box */
/* ------------------------------- */
static int
textbox( txt, y, nlines, maxlen, extenddown )
char *txt;
double y; /* bottom of text at this location in y */
int nlines;
int maxlen;
double extenddown; /* extend box area below last line of text this distance in y */
{
double lside, rside, top, bot;

if( tolower( Textalign[0] ) == 'l' ) ltext( txt, (EWinx/2.0)-((maxlen*Ecurtextwidth)/2.0), 
					y + (nlines*Ecurtextheight) );
else centeredtext( txt, (EWinx/2.0), y + (nlines*Ecurtextheight));

/* make frame a standard size for small amounts of text; otherwise
	scale to size of text.. */
if( maxlen * Ecurtextwidth < 2.8 ) {
	lside = (EWinx/2.0) - 1.5;
	rside = (EWinx/2.0) + 1.5;
	}
else	{
	lside = ((EWinx/2.0) - ((maxlen/2)*Ecurtextwidth)) - 0.3;
  	rside = ((EWinx/2.0) + ((maxlen/2)*Ecurtextwidth)) + 0.3;
	}
bot = y-extenddown;
	
top = y+((nlines+2.5)*Ecurtextheight); 

frame( lside, bot, rside, top );

return( 0 );
}


/* ----------------------------- */
/* EXPANDTEXT - execute any shell commands embedded in the 'in' parameter
   and include the results.  Shell command must occupy one line; line must begin with !.
   Results and all other text are copied into the 'out' parameter, which must be at 
   least 'outlen' chars */
/* ----------------------------- */
static int
expandtext( in, out, outlen )
char *in;
char *out;
int outlen; /* buffer max size */
{
int i;
char line[256];
char com[256];
char tmpfile[100];
FILE *fp;

sprintf( tmpfile, "/tmp/getgui%d.tmp", geteuid() );

strcpy( out, "" );
i = 0;
while( 1 ) {
	if( i >= strlen( in ) ) break;
	GL_getseg( line, in, &i, "\n" );
	if( line[0] == '!' ) {
		sprintf( com, "%s > %s 2> %s", &line[1], tmpfile, tmpfile );
		system( com );
		fp = fopen( tmpfile, "r" );
		if( fp == NULL ) {
			fprintf( stderr, "Error: expandtxt: cannot open %s for command results\n", tmpfile );
			continue;
			}
		while( fgets( line, 255, fp ) != NULL ) {
			if( ( strlen( out ) + strlen( line ) +1 ) >= outlen ) {
				fprintf( stderr, "Warning: expandtxt: text truncated\n" );
				break;
				}
			strcat( out, line );
			}
		fclose( fp );
		unlink( tmpfile );
		}
	else 	{
		if( ( strlen( out ) + strlen( line ) +1 ) >= outlen ) {
			fprintf( stderr, "Warning: expandtxt: text truncated\n" );
			break;
			}
		strcat( out, line );
		strcat( out, "\n" );
		}
	}
return( 0 );
}




/* ================== */
/* ================== */
/* RENDERING ROUTINES */
/* ================== */
/* ================== */

/* ------------------------------- */
/* ERASE - clear and initialize window for a new display */
/* ------------------------------- */
static int erase()
{
Eclr(); NDL = 0;
/* Esemfile(); */
Eflush();
return( 0 );
}

/* ------------------------------- */
/* BUTTONROW - draw a row of buttons */
/* ------------------------------- */
static int
buttonrow( taglist, cx, cy )
char *taglist; /* comma-delimited list of button labels */
double cx, cy; /* button row will be centered on this point */
{
double toptxt, midwin;
char btntxt[20][50];
int i, j;
int nbtn;
double btnlen, btnsep, groupwidth, totlen, pos, btnwidth;


/* parse button list.. */
i = 0;
j = 0;
totlen = 0;
while( 1 ) {
	GL_getseg( btntxt[j], taglist, &i, "," );
	if( strlen( btntxt[j] ) < 1 ) break;
	totlen += strlen( btntxt[j] );
	j++;
	}
nbtn = j;

/* figure out where to begin drawing buttons.. */
btnsep = 0.3;		/* distance between buttons */
groupwidth = (totlen * Ecurtextwidth) + ((nbtn-1) * btnsep);
pos = cx - (groupwidth/2.0);

for( i = 0; i < nbtn; i++ ) {
	button1( btntxt[i], pos, cy, 1, (i==(Buttondefault-1))?1:0, &btnwidth );
	pos += (btnwidth + btnsep);
	}
return( 0 );
}

/* ------------------------------- */
/* BUTTON1 - draw one button */
/* ------------------------------- */
static int
button1( txt, x, y, mode, mark, btnwidth )
char *txt; 	/* label */
double x;	/* left side of button */
double y;	/* y midpoint of button */
int mode; 	/* 1 = normal colors; 0 = inverse colors */
int mark;	/* 1 = mark with surrounding box; 0 = don't */
double *btnwidth; /* returned- width of the button */
{
double btnhi, width;
char color[40];
double x1, y1, x2, y2;
double oldlw;

if( mode == 1 ) strcpy( color, Color1 );
else strcpy( color, Color2 );

btnhi = 0.2;		/* height of button / 2 */
width = ( strlen( txt )  * Ecurtextwidth );
*btnwidth = width;
x1 = x-0.05;
y1 = y-btnhi;
x2 = x+width+0.05;
y2 = y+btnhi;
Ecblock( x1, y1, x2, y2, color, 0 );
Ecblockdress( x1, y1, x2, y2, 0.1, "gray(0.7)", "gray(0.9)", 0.0, "" );
if( Keepdl ) getgui_dladd( "B", txt, x1, y1, x2, y2, x, y, Ecurtextsize, mark, 0, 0, 0 );
Emov( x, y - 0.1 );
Etext( txt );
if( mark ) { 
	oldlw = Ecurlinewidth;
	Elinetype( 1, 1.5, 1.0 );
	Ecblock( x1-0.07, y1-0.07, x2+0.07, y2+0.07, "", 1 );
	Elinetype( 0, oldlw, 1.0 );
	}
return( 0 );
}



/* ------------------------------- */
/* CENTEREDTEXT - draw some centered text */
/* ------------------------------- */
static int
centeredtext( txt, cx, y )
char *txt; 	/* the text to display.  may contain embedded newlines. */
double cx;	/* text will be centered around this x loc */
double y;	/* (first) line of text will rest on this y loc */
{
int i;
char line[256];

/* break up on newlines */
i = 0;
while( 1 ) {
	if( i >= strlen( txt ) ) break;
	GL_getseg( line, txt, &i, "\n" );
	Emov( cx, y );
	if( Keepdl ) getgui_dladd( "C", line, 0.0, 0.0, 0.0, 0.0, cx, y, Ecurtextsize, 0, 0, 0, 0 );
	Ecentext( line );
	y -= Ecurtextheight;
	if( y < 0.0 ) { 
		fprintf( stderr, "Warning: text truncated\n" );
		return( 0 );
		}
	}
return( 0 );
}
/* ------------------------------- */
/* LTEXT - draw some left-adjusted text */
/* ------------------------------- */
static int
ltext( txt, x, y )
char *txt; 	/* the text to display.  may contain embedded newlines. */
double x;	/* text will begin at this x loc */
double y;	/* (first) line of text will rest on this y loc */
{
int i;
char line[256];

/* break up on newlines */
i = 0;
while( 1 ) {
	if( i >= strlen( txt ) ) break;
	GL_getseg( line, txt, &i, "\n" );
	Emov( x, y );
	if( Keepdl ) getgui_dladd( "L", line, 0.0, 0.0, 0.0, 0.0, x, y, Ecurtextsize, 0, 0, 0, 0 );
	Etext( line );
	y -= Ecurtextheight;
	if( y < 0.0 ) { 
		fprintf( stderr, "Warning: text truncated\n" );
		return( 0 );
		}
	}
return( 0 );
}

/* -------------------------------- */
/* FRAME - draw a rectangular frame */
/* -------------------------------- */
static int
frame( x1, y1, x2, y2 )
double x1, y1, x2, y2;
{
double hw, hh;
Ecblockdress( x1, y1, x2, y2, 0.1, "gray(0.7)", "gray(0.9)", 0.0, "" );
getgui_dladd( "F", "", x1, y1, x2, y2, 0.0, 0.0, 0, 0, 0, 0, 0 );
return( 0 );
}


/* ================== */
/* DISPLAY LIST ROUTINES */
/* ================== */
/* Display list format:
   What        typ val          x1 y1 x2 y2 p1 p2 i1       i2    i3 i4
   --------    --- ---          -- -- -- -- -- -- -------- ----- -- --
   Buttons  	B selection 	x1 y1 x2 y2 x  y  textsize mark  -  - 
   Centeredtext C text 		x1 y1 x2 y2 cx y  textsize -     -  -
   Lefttext     L text          -  -  -  -  x  y  textsize -     -  - 
   Frame	F -		x1 y1 x2 y2
   Entryarea	E contents	x1 y1 x2 y2 x  y  mode     len pos textsize
   Editbox      M ?             x1 y1 x2 y2 x  y  mode     len pos textsize

*/

/* -------------------------------- */
/* GETGUI_DLADD - add an entry to dislay list.  Index to entry is returned. */
/* -------------------------------- */
getgui_dladd( typ, tag, x1, y1, x2, y2, p1, p2, i1, i2, i3, i4, i5 )
char *typ, *tag;
double x1, x2, y1, y2, p1, p2;
int i1, i2, i3, i4, i5;
{
if( NDL >= 200 ) {
	fprintf( stderr, "Error: display list is full\n" );
	return( NDL-1 );
	}
strcpy( DLtyp[NDL], typ );
if( typ[0] == 'M' ) {
	strcpy( &DLbigbuf[ DLbigbufsize ], tag );
	sprintf( DLval[NDL], "%d", DLbigbufsize );
	DLbigbufsize += DLi2[NDL]; /* reserve space based on editpp's buflen.. */
	}
else strcpy( DLval[NDL], tag );
DLx1[NDL] = x1; DLy1[NDL] = y1; DLx2[NDL] = x2; DLy2[NDL] = y2;
DLp1[NDL] = p1; DLp2[NDL] = p2;
DLi1[NDL] = i1; DLi2[NDL] = i2; DLi3[NDL] = i3; DLi4[NDL] = i4; DLi5[NDL] = i5;
NDL++;
return( NDL-1 );
}

/* --------------------------------- */
/* GETGUI_DLFIND - determine which object in bounds list x,y is within.
 * Search begins with latest-added object and ends with first-added object.
 * Returns an index into the display list, or -1 if not found. */
/* --------------------------------- */
getgui_dlfind( x, y )
double x, y;
{
int i;
for( i = NDL-1; i >= 0; i-- ) {
	if( x >= DLx1[i] && x <= DLx2[i] && y >= DLy1[i] && y <= DLy2[i] ) {
		if( strcmp( DLtyp[i], "F" ) != 0 ) return( i );
		}
	}
return( -1 );
}

#ifdef SUSPEND
/* ----------------------------------------------------- */
/* E_HANDLE_EVENTS - The following is called whenever a window is
 * exposed or resized. Action: redraw everything based on info in
 * display list. */
/* ----------------------------------------------------- */
Ehandle_events( x, y, e )
double x, y;
int e;
{
int i;
int oldk;
double w;

if( e == E_COLORMAP_FULL ) {
	/* no more X11 colors available; drop back to black/white.. */
	if( Reserving_colors == 1 ) {
		fprintf( stderr, "Warning: color map full, can't allocate basic colors.\n" );
		/* exit(1); */
		}
	else if( Reserving_colors == 2 ) { /* drop back to basic colors.. */
		strcpy( Color1, "white" );
		strcpy( Color2, "0.8" );
		strcpy( Color3, "0.8" );
		strcpy( Color4, "white" );
		Ebackcolor( "white" );
		}
	else return( 0 );
	}
else if( e == E_MONODISPLAY ) {
	Mono_display = 1;
	return( 0 );
	}
else if( e != E_EXPOSE && e != E_RESIZE ) return( 0 );

if( e == E_RESIZE ) { EWinx = x; EWiny = y; }

oldk = Keepdl;
Keepdl = 0;
/* redraw everything, based on info in display list.. */
redraw_all();

Keepdl = oldk;
return( 0 );
}
#endif

/* -------------- */
static char *
keyrep( key )
int key;
{
static char buf[20];
 
/*       enter      space       backsp      del           esc          tab  */
if( key > 1000 ) {
	if( key == 1001 ) sprintf( buf, ".!mouseleft" );
	else if( key == 1002 ) sprintf( buf, ".!mousemiddle" );
	else if( key == 1003 ) sprintf( buf, ".!mouseright" );
	}
else if( key > 550 ) {
	if( key == 551 ) sprintf( buf, ".!leftarrow" );
	if( key == 552 ) sprintf( buf, ".!uparrow" );
	if( key == 553 ) sprintf( buf, ".!rightarrow" );
	if( key == 554 ) sprintf( buf, ".!downarrow" );
	if( key == 555 ) sprintf( buf, ".!pageup" );
	if( key == 556 ) sprintf( buf, ".!pagedown" );
	}
else if( key == 13 || key == 32 || key == 8 || key == 127 || key == 27 || key == '\t'
        || ! isprint( key ) ) {
        sprintf( buf, ".!char%d", key );
        return( buf );
        }
else sprintf( buf, "%c", key );
 
return( buf );
}


#ifdef SUSPEND
/* --------------------------------------- */
/* REDRAW_ALL - redraw everything. */
/* --------------------------------------- */
static int
redraw_all()
{
int i;
double w;
int mod;

Eclr(); /* Esemfile(); */
for( i = 0; i < NDL; i++ ) {

	/* printf( "redraw: i=%d  type=%c  val=%s\n", i, DLtyp[i][0], DLval[i] ); fflush( stdout ); */
	if( DLtyp[i][0] == 'B' ) {
		if( Ecurtextsize != DLi1[i] ) Etextsize( DLi1[i] );
		button1( DLval[i], DLp1[i], DLp2[i], 1, DLi2[i], &w );
		}

	else if( DLtyp[i][0] == 'C' ) {
		if( Ecurtextsize != DLi1[i] ) Etextsize( DLi1[i] );
		Emov( DLp1[i], DLp2[i] );
		Ecentext( DLval[i] );
		}

	else if( DLtyp[i][0] == 'L' ) {
		if( Ecurtextsize != DLi1[i] ) Etextsize( DLi1[i] );
		Emov( DLp1[i], DLp2[i] );
		Etext( DLval[i] );
		}

	else if( DLtyp[i][0] == 'F' ) 
		Ecblockdress( DLx1[i], DLy1[i], DLx2[i], DLy2[i], 
			0.1, "gray(0.7)", "gray(0.9)", 0.0, "" );

	else if( DLtyp[i][0] == 'E' ) {
		int mode;
		if( DLi1[i] == 'D' ) mode = 'D';
		else if( DLi1[i] == 'P' ) mode = 'X';
		else mode = 'R';
		if( Ecurtextsize != DLi4[i] ) Etextsize( DLi4[i] );
		getgui_editln( mode, DLval[i], DLp1[i], DLp2[i], DLi2[i], &DLi3[i], &mod );
		}

	else if( DLtyp[i][0] == 'M' ) {
		int mode;
		if( Ecurtextsize != DLi4[i] ) Etextsize( DLi4[i] );
		if( DLi1[i] == 'E' ) mode = 'R';
		else mode = DLi1[i];
		getgui_editpp( mode, &DLbigbuf[atoi(DLval[i])], DLp1[i], DLp2[i], 
			DLi2[i], DLi5[i], &DLi3[i], &mod, "" );
		}

	else fprintf( stderr, "Don't know how to redraw type %c\n", DLtyp[i][0] );
	}
}
#endif



/* =================== */
/* =================== */
/* USER INPUT HANDLER  */
/* =================== */
/* =================== */

/* Returns 1 if there is a result, 0 if not */
static int
handle_input( x, y, e, result )
double x, y;
int e;
char *result;
{
int i;
double w;
int mod;

i = getgui_dlfind( x, y );
if( i < 0 ) return( 0 );
else if( strcmp( DLtyp[i], "B" )==0 ) {
	button1( DLval[i], DLp1[i], DLp2[i], 0, DLi2[i], &w );
	Eflush();
	usleep( Flashtime );
	button1( DLval[i], DLp1[i], DLp2[i], 1, DLi2[i], &w );
	strcpy( result, DLval[i] );
	return( 1 );
	}
else if( strcmp( DLtyp[i], "E" )==0 ) {
	int mode;
        if( Ecurtextsize != DLi4[i] ) Etextsize( DLi4[i] );
        getgui_editln( DLi1[i], DLval[i], DLp1[i], DLp2[i], DLi2[i], &DLi3[i], &mod );
	}
return( 0 );
}

/* ============================== */
/* MEASURETEXT - count the number of lines present in txt and find the length of longest line. */
/* (copied from ploticus lib.c) */
static int
Emeasuretext( txt, nlines, maxlen )
char *txt;
int *nlines, *maxlen;
{
int i, len, tlen;
char line[256];

i = 0;
*nlines = 0;
*maxlen = 0;
tlen = strlen( txt );
while( 1 ) {
        if( i >= tlen ) break;
        GL_getseg( line, txt, &i, "\n" );
        len = strlen( line );
        if( len > *maxlen ) *maxlen = len;
        (*nlines)++;
        }
return( 0 );
}

